%global debug_package   %{nil}
%global provider        github
%global provider_tld    com
%global project         sensu
%global repo            uchiwa
%global import_path     %{provider}.%{provider_tld}/%{project}/%{repo}
%global commit          0.4.1
%global shortcommit     %(c=%{commit}; echo ${c:0:7})
%global networking      0

Name:           %{repo}
Version:        %{commit}
Release:        1%{?dist}
Summary:        Uchiwa is a simple dashboard for the Sensu monitoring framework, built with Go and AngularJS.
License:        MIT
URL:            https://%{import_path}
Source0:        https://%{import_path}/archive/%{commit}/%{repo}-%{shortcommit}.tar.gz
Source1:        uchiwa.service
Source2:        uchiwa.json
Source3:        uchiwa_bower_components-20150205.tar.gz
BuildRequires:  systemd
BuildRequires:  golang(github.com/bencaron/gosensu)
BuildRequires:  golang(github.com/goji/httpauth)
BuildRequires:  golang(github.com/palourde/logger)
BuildRequires:  golang(github.com/stretchr/testify)
Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd

%description
%{summary}

%package devel
BuildArch:      noarch
BuildRequires:  golang >= 1.2.1-3
Requires:       golang >= 1.2.1-3
Summary:        %{summary}
Provides:       golang(%{import_path}) = %{version}-%{release}
Provides:       golang(%{import_path}/uchiwa) = %{version}-%{release}

%description devel
%{summary}

This package contains library source intended for 
building other packages which use %{project}/%{repo}.

%prep
%setup -q -n %{repo}-%{commit}

%build
# set up temporary build gopath, and put our directory there
mkdir -p ./_build/src/github.com/sensu
ln -s $(pwd) ./_build/src/github.com/sensu/uchiwa

export GOPATH=$(pwd)/_build:%{gopath}
go build .

%install
mkdir -p %{buildroot}%{_bindir}
install uchiwa-%{version} %{buildroot}%{_bindir}/uchiwa

mkdir -p %{buildroot}%{_unitdir}
install -p -m 0644 %{SOURCE1} %{buildroot}%{_unitdir}/

mkdir -p %{buildroot}%{_sysconfdir}/%{name}
install -m 0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/%{name}

install -d -p %{buildroot}/%{gopath}/src/%{import_path}/
cp -pav *.go %{buildroot}/%{gopath}/src/%{import_path}/
cp -rpav uchiwa %{buildroot}/%{gopath}/src/%{import_path}/
cp -rpav public %{buildroot}/%{gopath}/src/%{import_path}/
tar -xzf %{SOURCE3} -C %{buildroot}/%{gopath}/src/%{import_path}/public
cp -rpav docker %{buildroot}/%{gopath}/src/%{import_path}/
cp -rpav test %{buildroot}/%{gopath}/src/%{import_path}/

%check
%if 0%{networking} > 0
GOPATH=%{buildroot}/%{gopath}:%{gopath} go test %{import_path}/uchiwa
%endif

%files
%{_bindir}/uchiwa
%{_unitdir}/uchiwa.service
%attr(750, nobody, nobody) %dir %{_sysconfdir}/%{name}
%attr(640, nobody, nobody) %config(noreplace) %{_sysconfdir}/%{name}/%{name}.json
%{gopath}/src/%{import_path}/public

%files devel
%doc CHANGELOG.md README.md LICENSE
%dir %{gopath}/src/%{provider}.%{provider_tld}/%{project}
%exclude %{gopath}/src/%{import_path}/public
%{gopath}/src/%{import_path}

%post
%systemd_post uchiwa.service

%preun
%systemd_preun uchiwa.service

%postun
%systemd_postun uchiwa.service

%changelog
* Mon Feb 02 2015 Graeme Gillies <ggillies@redhat.com> - 0.4.1-1
- First package for Fedora


